/**
  * @file st756xx.h
  * @author generated by mrt-device utility 
  * @link [https://mrt.readthedocs.io/en/latest/pages/mrtutils/mrt-device.html]
  * @brief Device driver for st756xx device
  *
  *
  */

#ifdef __cplusplus
extern "C"
{
#endif

/* Includes ------------------------------------------------------------------*/
#include <stdint.h>
#include <stdbool.h>
#include "st756xx_regs.h"
#include "Platforms/Common/mrt_platform.h"
#include "Utilities/GFX/Gfx/gfx.h"

/*user-block-top-start*/
/*user-block-top-end*/


/* Exported types ------------------------------------------------------------*/

typedef struct{
    mrt_spi_handle_t  mSpiHandle;   //spi handle
    mrt_gpio_t mChipSelect;         //chip select pin
    mrt_gpio_t mCmdData;            //command/data pin
    gfx_t mCanvas;
}st756xx_t;


/* Exported functions ------------------------------------------------------- */


/**
 * @brief initializes st756xx device hw 
 * @param dev ptr to st756xx device
 * @param spi handle for i2c bus
 * @param chipSelect gpio for chip select
 * @param cmdData gpio for command/data
 */
mrt_status_t st756xx_init_hw(st756xx_t* dev, mrt_spi_handle_t spi, mrt_gpio_t chipSelect, mrt_gpio_t cmdData);



mrt_status_t st756xx_init_canvas(st756xx_t* dev, int width, int height);

/**
  *@brief tests interface with device
  *@param dev ptr to st756xx device
  *@return MRT_STATUS_OK if test is passed 
  *@return MRT_STATUS_ERROR if test fails
  */
mrt_status_t st756xx_test(st756xx_t* dev);

/**
 * @brief sets the display orientation
 * @param dev ptr to st756xx device
 * @param cmd 
 */
mrt_status_t st756_write_cmd(st756xx_t* dev, uint8_t cmd);


/**
 * @brief writes data to display
 * @param dev ptr to st756xx device
 * @param data data to be written
 * @param len length of data
 */
mrt_status_t st756_write_data(st756xx_t* dev, uint8_t* data, int len);


/**
 * @brief Updates display from buffer
 * @param dev ptr to st756xx device
 */
mrt_status_t st756xx_refesh(st756xx_t* dev);


/*user-block-bottom-start*/
/*user-block-bottom-end*/

#ifdef __cplusplus
}
#endif